﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4
@EndOfDesignText@
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Private UI As ESPUI
	Public wifi As ESP8266WiFi
	Private mainTab, labStatus, mainTemp, mainPressure, mainHumidity, mainSpeed, mainRain, mainWind As UInt
	Private timeTab, timeTime, timeYearSlider, timeMonthSlider, timeDaySlider, timeHourSlider, timeMinSlider, timeSecSlider As UInt
	Private sdcardTab, sdcardStatus As UInt
	Private flugTab, flugLabel As UInt
	Private wifitab, wifi_ssid_text, wifi_pass_text, wifiAPmodeSwitcher As UInt
	Private infoTab, infoDevice As UInt

	Private timUpdate As Timer
	Private FailedCounter As Byte
	Private FailLimit As Byte = 2
	Public APmode As Boolean = True	'AP connection is by default
	Private UIalreadyCreated As Boolean
End Sub

Sub Start(tag As Byte)
	Delay(500)
	Main.SDlog(Array As String("Internet-connection is starting ....."))
   
	If UIalreadyCreated = False Then
		UIalreadyCreated = True
		Main.SDlog(Array As String("Web Interface starting ....."))
		UI.Initialize("OnExtendedCB")
	
		setUpUI
		
		UI.begin("Интырфейс","","",80)
		Log("Server started OK")
		timUpdate.Initialize("timUpdate_Tick", 2000)
		timUpdate.Enabled = True
	End If
End Sub




Sub isWiFiConnected As Boolean
	Return wifi.IsConnected
End Sub

'// This is the main function which builds our GUI
Private Sub setUpUI

'	//Turn off verbose debugging
	UI.setVerbosity(UI.Verb_Quiet)

'	//Make sliders continually report their position As they are being dragged.
	UI.sliderContinuous = True

'	/*
'	 * TAB: Main Controls
'	 * This TAB contains all the basic ESPUI controls, And shows how To read And update them at runtime.
'	 *-----------------------------------------------------------------------------------------------------------*/
	labStatus = UI.addControl2(UI.ControlTyp_Label, "Device status", others.SelfStatus, UI.Controlcol_Peterriver)
	mainTab = UI.addControl1(UI.ControlTyp_TAB, "", "Data")
	
	
	mainTemp = UI.addControl3(UI.ControlTyp_Label, "Temperature, °C", NumberFormat(1, 1, 1), UI.Controlcol_Peterriver, mainTab)
	mainPressure = UI.addControl3(UI.ControlTyp_Label, "Pressure, mm hg.", NumberFormat(2, 1, 1), UI.Controlcol_Peterriver, mainTab)
	mainHumidity = UI.addControl3(UI.ControlTyp_Label, "Humi, %", NumberFormat(3, 1, 1), UI.Controlcol_Peterriver, mainTab)

	mainSpeed = UI.addControl3(UI.ControlTyp_Label, "Speed, m/s", NumberFormat(4, 1, 2), UI.Controlcol_Peterriver, mainTab)
	mainRain = UI.addControl3(UI.ControlTyp_Label, "Rain, mm", NumberFormat(5, 1, 3), UI.Controlcol_Peterriver, mainTab)
	mainWind = UI.addControl3(UI.ControlTyp_Label, "Wind, °", NumberFormat(6, 1, 1), UI.Controlcol_Peterriver, mainTab)
	
	UI.setPanelWide(labStatus, True)
	
	Styling
	
'	/*
'	 * TAB: Time controls
'	 *-----------------------------------------------------------------------------------------------------------*/
	timeTab = UI.addControl1(UI.ControlTyp_Tab, "", "Date and time")

	timeTime = UI.addControl3(UI.ControlTyp_Label, "Set intermal date and time", "Set intermal date and time", UI.Controlcol_Peterriver, timeTab)
	Dim preYear, preMonth, preDay, preHour, preMin, preSec As Byte
	preYear = 24
	preMonth = 8
	preDay = 24
	preHour = 0
	preMin = 0
	preSec = 0

	
	timeYearSlider = UI.addControl_CB(UI.ControlTyp_slider, "Год", preYear, UI.Controlcol_Turquoise, timeTab, 0)					'generalCallback
	UI.addControl3(UI.ControlTyp_Min, "", "24", UI.Controlcol_Peterriver, timeYearSlider)
	UI.addControl3(UI.ControlTyp_Max, "", "99", UI.Controlcol_Peterriver, timeYearSlider)
	
	timeMonthSlider = UI.addControl_CB(UI.ControlTyp_slider, "Месяц", preMonth, UI.Controlcol_Turquoise, timeTab, 0)					'generalCallback
	UI.addControl3(UI.ControlTyp_Min, "", "1", UI.Controlcol_Peterriver, timeMonthSlider)
	UI.addControl3(UI.ControlTyp_Max, "", "12", UI.Controlcol_Peterriver, timeMonthSlider)
	
	timeDaySlider = UI.addControl_CB(UI.ControlTyp_slider, "Число", preDay, UI.Controlcol_Turquoise, timeTab, 0)					'generalCallback
	UI.addControl3(UI.ControlTyp_Min, "", "1", UI.Controlcol_Peterriver, timeDaySlider)
	UI.addControl3(UI.ControlTyp_Max, "", "31", UI.Controlcol_Peterriver, timeDaySlider)
		
	timeHourSlider = UI.addControl_CB(UI.ControlTyp_slider, "Час", preHour, UI.Controlcol_Turquoise, timeTab, 0)					'generalCallback
	UI.addControl3(UI.ControlTyp_Min, "", "0", UI.Controlcol_Peterriver, timeHourSlider)
	UI.addControl3(UI.ControlTyp_Max, "", "23", UI.Controlcol_Peterriver, timeHourSlider)
	
	timeMinSlider = UI.addControl_CB(UI.ControlTyp_slider, "Минута", preMin, UI.Controlcol_Turquoise, timeTab, 0)					'generalCallback
	UI.addControl3(UI.ControlTyp_Min, "", "0", UI.Controlcol_Peterriver, timeMinSlider)
	UI.addControl3(UI.ControlTyp_Max, "", "59", UI.Controlcol_Peterriver, timeMinSlider)
	
	timeSecSlider = UI.addControl_CB(UI.ControlTyp_slider, "Секунда", preSec, UI.Controlcol_Turquoise, timeTab, 0)					'generalCallback
	UI.addControl3(UI.ControlTyp_Min, "", "0", UI.Controlcol_Peterriver, timeSecSlider)
	UI.addControl3(UI.ControlTyp_Max, "", "59", UI.Controlcol_Peterriver, timeSecSlider)
	
	UI.addControl_CB(UI.ControlTyp_Button, "Save into the device", "Save", UI.Controlcol_Peterriver, timeTab, 100)
	
	
	'PARTIALLY COMMENTED INTERFACE, try to uncomment for test
	
'
''	/*
''	 * TAB: SD-card
''	 *-----------------------------------------------------------------------------------------------------------*/
'	sdcardTab = UI.addControl1(UI.ControlTyp_TAB, "SD-карта", "SD-карта")
'	sdcardStatus = UI.addControl3(UI.ControlTyp_Label, "Статус SD-карты", others.SD_status, UI.Controlcol_Peterriver, sdcardTab)
'	UI.setPanelWide(sdcardStatus, True)
'	
'	'----------------------
'	infoTab = UI.addControl1(UI.ControlTyp_TAB, "", "Инфо")
'	Dim info As String = JoinStrings(Array As String(others.DeviceName, CRLF, "", others.APname, CRLF, "Батарея, %", 123))
'	infoDevice = UI.addControl3(UI.ControlTyp_Label, "Метеостанция Orion", info, UI.Controlcol_Peterriver, infoTab)
	
	'setUpUI2
	Log("Interface is loaded")
End Sub

Private Sub Styling
	Dim PanelWidth As String = "display: flex;justify-content: center;align-items: center;width = 50%"
	Dim DigitsLabelSize As String = "font-size: 300%;background-color: transparent;"
	
	UI.setPanelStyle(mainTemp, PanelWidth,-1)
	UI.setPanelStyle(mainPressure, PanelWidth,-1)
	UI.setPanelStyle(mainHumidity, PanelWidth,-1)
	UI.setPanelStyle(mainSpeed, PanelWidth,-1)
	UI.setPanelStyle(mainRain, PanelWidth,-1)
	UI.setPanelStyle(mainWind, PanelWidth,-1)
	
	UI.setElementStyle(mainTemp, DigitsLabelSize,-1)
	UI.setElementStyle(mainPressure, DigitsLabelSize,-1)
	UI.setElementStyle(mainHumidity, DigitsLabelSize,-1)
	UI.setElementStyle(mainSpeed, DigitsLabelSize,-1)
	UI.setElementStyle(mainRain, DigitsLabelSize,-1)
	UI.setElementStyle(mainWind, DigitsLabelSize,-1)
End Sub

Private Sub setUpUI2
	'	/*
	'	 * TAB: wifi Credentials
	'	 * You use this TAB To enter the SSID And password of a wifi network To autoconnect To.
	'	 *-----------------------------------------------------------------------------------------------------------*/
	wifitab = UI.addControl1(UI.ControlTyp_TAB, "", "WiFi")
	UI.addControl3(UI.ControlTyp_Label, "Внимание:", "Сначала сохраните верные имя и пароль вашей Wifi-сети прежде чем переключать AP-режим, если не верные - станция вернется в AP-режим через минуту", UI.Controlcol_Peterriver, wifitab)

	wifi_ssid_text = UI.addControl_CB(UI.ControlTyp_Text, "Имя вашей WiFi сети (SSID)", "", UI.Controlcol_Alizarin, wifitab,13)						'textCallback  ***************
	'	//Note that adding a "Max" control To a text control sets the Max length
	UI.addControl3(UI.ControlTyp_Max, "", "32", UI.Controlcol_None, wifi_ssid_text)
	wifi_pass_text = UI.addControl_CB(UI.ControlTyp_Password, "Пароль сети", "", UI.Controlcol_Alizarin, wifitab,14)					'textCallback  *************
	UI.setInputType(wifi_pass_text, "password", -1)
	UI.addControl3(UI.ControlTyp_Max, "", "64", UI.Controlcol_None, wifi_pass_text)
	UI.addControl_CB(UI.ControlTyp_Button, "Сохранить SSID и пароль", "Сохранить", UI.Controlcol_Peterriver, wifitab,15)								'enterWifiDetailsCallback *************
	wifiAPmodeSwitcher = UI.addControl_CB(UI.ControlTyp_Switcher, "WiFi AP-режим", "WiFi AP-режим", UI.Controlcol_Peterriver, wifitab, 103)

	
	'----------------------
	flugTab = UI.addControl1(UI.ControlTyp_TAB, "Флюгер", "Флюгер")
	flugLabel = UI.addControl3(UI.ControlTyp_Label, "Калибровка флюгера", LongText1, UI.Controlcol_Peterriver, flugTab)
	UI.setPanelWide(flugLabel, True)
	Dim but As UInt = UI.addControl_CB(UI.ControlTyp_Button, "Сохраняйте калибровку флюгера в метеостанцию при каждом ее перемещении !", "Сохранить", UI.Controlcol_Peterriver, flugTab, 101)
	UI.setPanelWide(but, True)

End Sub

Private Sub LongText1 As String
	Return "Флюгер - датчик направления ветра. Его показания зависят от ориентации метеостанции в пространстве: <br><br>1) установите метеостанцию в удобном месте, <br><br>2) по компасу выставьте направление стрелки флюгера c Севера на Юг <br><br>3) и нажмите на кнопку, чтобы сохранить текущее направление ветра с флюгера как северное"
End Sub

Private Sub OnExtendedCB(ControlId As UInt, ControlType As Byte,ControlLabel As String, ControlValue As String, eventType As Int, userData As ULong)
	If ControlType <> 20 Then 
		Main.SDlog(Array As String("ControlId=",ControlId," ControlType=",ControlType, " ControlLabel='",ControlLabel, "' ControlValue='",ControlValue, "' eventType=", eventType, " userData=",userData))
	End If
	Select ControlType
		Case UI.ControlTyp_Title		 '0
			
		Case UI.ControlTyp_pad 			 '1

		Case UI.ControlTyp_PadWithCenter '2

		Case UI.ControlTyp_Button		'3
			If userData = 100 And eventType = UI.CBEvent_B_DOWN Then saveTimeCallback 'save time
			If userData = 101 And eventType = UI.CBEvent_B_UP Then saveFlugCallback 'save flug calib
			If userData = 15 And eventType = UI.CBEvent_B_UP Then saveWiFiCallback
		Case UI.ControlTyp_Label		'4

		Case UI.ControlTyp_Switcher		'5
			If ControlId = wifiAPmodeSwitcher Then APswitcherCallback(ControlId)
		Case UI.ControlTyp_Slider		'6
			'	slider(ControlId, ControlType, ControlLabel, ControlValue, eventType)
		Case UI.ControlTyp_Number		'7
			'	numberCall(ControlId, ControlType, ControlLabel, ControlValue, eventType)
		Case UI.ControlTyp_Text			'8
			If userData = 13 Then textCallback(ControlId, ControlType,ControlLabel, ControlValue, eventType, userData)
		Case UI.ControlTyp_Password
			If userData = 14 Then textCallback(ControlId, ControlType,ControlLabel, ControlValue, eventType, userData)
	End Select
End Sub

Private Sub APswitcherCallback(ControlId As UInt)
	APmode = IIf(UI.GetControlValue(ControlId) = "0", False, True)
	'Main.Nvs.setByte("APmode", IIf(APmode, 1, 0), True)
	If APmode Then
		Show_status(labStatus, JoinStrings(Array As String("Режим WiFi AP, подключайтесь к сети: ", others.APname, " и открывайте http://192.168.4.1", wifi.LocalIp)), False)
	Else
		Show_status(labStatus, JoinStrings(Array As String("Режим WiFi, подключайтесь к сети: ")), False)
	End If
	Main.SDlog(Array As String("APmode switched:", APmode))
	others.restart(2)
	'Start(2)
End Sub

Private Sub saveFlugCallback

	Show_status(labStatus, "Флюгер - откалиброван", False)
End Sub

Private Sub saveTimeCallback
	Dim yy As Byte = UI.getControlValue(timeYearSlider)
	Dim mon As Byte = UI.getControlValue(timeMonthSlider)
	Dim day As Byte = UI.getControlValue(timeDaySlider)
	Dim h As Byte = UI.getControlValue(timeHourSlider)
	Dim mi As Byte = UI.getControlValue(timeMinSlider)
	Dim sec As Byte = UI.getControlValue(timeSecSlider)

	'saving is skipped yet for testing the interface
		Show_status(labStatus, "Часы установлены", False)

End Sub

Private Sub saveWiFiCallback
	If UI.getControlvalue(wifi_ssid_text) = "" Then
		Show_status(labStatus, "Ошибка ввода", True)
		Return
	End If
	GlobalStore.Put(0, UI.getControlvalue(wifi_ssid_text))
	GlobalStore.Put(1, UI.getControlvalue(wifi_pass_text))

	Show_status(labStatus, "Данные WiFi сохранены. Выберите режим AP или нет", False)
End Sub

'13 / 14
Sub textCallback(ControlId As UInt, ControlType As Byte, ControlLabel As String, ControlValue As String, eventType As Int, userData As ULong)
	'//This callback is needed To handle the changed values, even though it doesn't do anything itself.
End Sub


Private Sub timUpdate_Tick
	UI.updateLabel(timeTime, others.Date_Time)
	Delay(10)
	UI.updateLabel(mainTemp, NumberFormat(1, 1, 1))
	Delay(10)
	UI.updateLabel(mainPressure, NumberFormat(2, 1, 1))
	Delay(10)
	UI.updateLabel(mainHumidity, NumberFormat(3, 1, 1))
	Delay(10)
	UI.updateLabel(mainSpeed, NumberFormat(4, 1, 2))
	Delay(10)
	UI.updateLabel(mainRain, NumberFormat(5, 1, 3))
	Delay(10)
	
	Dim status As String = others.SelfStatus
	Show_status(labStatus, status, IIf(status = "OK", False, True))
	
	Dim sd_status As String = others.SD_status
	Show_status(sdcardStatus, sd_status, IIf(sd_status = "OK", False, True))
	
	If True Then
		UI.updateLabel(mainWind, JoinStrings(Array As String(NumberFormat(6, 1, 1))))
	Else
		UI.updateLabel(mainWind, "-")
	End If
	Delay(10)
	
	UI.updateLabel(infoDevice, JoinStrings(Array As String("ИМЯ УСТРОЙСТВА", "<br><br>IP: ", wifi.LocalIp, " (подключайтесь к своей сети)", "<br><br>AP IP:", wifi.AccessPointIp, " (подключайтесь к сети '", "MYAPNAME", "')")))
	Delay(10)
	
	UI.updateSwitcher(wifiAPmodeSwitcher, APmode, -1)
	Delay(10)
	
End Sub

Private Sub Show_status(view As UInt, text As String, alarm As Boolean)
	UI.updateLabel(view, text)
	Delay(10)
	If Not(alarm) Then
		Dim LabelStyle As String = "background-color: green; width: 100%;"	'unset
	Else
		Dim LabelStyle As String = "background-color: red; width: 100%;"
	End If
	UI.setElementStyle(view, LabelStyle, -1)
	Delay(10)
End Sub