﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.9
@EndOfDesignText@
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Public const STARTMARKER As String = "<sensor>"
	Public const STOPMARKER As String = "</sensor>"
	Public const VOIDMARKER As String = "-99999999999"
	Public const IDSTARTMARKER As String = "<id="
	Public const IDSTOPMARKER As String = "=id>"
	Public MacArray(6) As Byte
	Public title As String = "Web-site title"
	
	Public ESP As ESP8266
	Public const MAGIC_EEPROM As Byte = 213
	Dim softconnected As Boolean
End Sub

Sub DeviceName As String
	Dim res As String = "DEVICE"
	Return res
End Sub

Sub Get_MacAddress() As Byte()
	RunNative("getMac", Null)
	Return MacArray
End Sub
#if C
#include "esp_mac.h"  //required - exposes esp_mac_type_t values

void getMac(B4R::Object* u) {
    esp_read_mac((Byte*)b4r_others::_macarray->data, ESP_MAC_WIFI_STA);
}
#end if

Public Sub restart (tag As Byte)
	Main.SDlog(Array As String("Planned restart: point ", tag))
	ESP.Restart
End Sub

'Public Sub ReplaceString(Original() As Byte, SearchFor() As Byte, ReplaceWith() As Byte) As Byte()
'	'count number of occurrences
'	Dim bc2 As ByteConverter
'	Dim c As Int = 0
'	Dim i As Int
'	If SearchFor.Length <> ReplaceWith.Length Then
'		i = bc2.IndexOf(Original, SearchFor)
'		Do While i > -1
'			c = c + 1
'			i = bc2.IndexOf2(Original, SearchFor, i + SearchFor.Length)
'		Loop
'	End If
'	Dim result(Original.Length + c * (ReplaceWith.Length - SearchFor.Length)) As Byte
'	Dim prevIndex As Int = 0
'	Dim targetIndex As Int = 0
'	i = bc2.IndexOf(Original, SearchFor)
'	Do While i > -1
'		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, i - prevIndex)
'		targetIndex = targetIndex + i - prevIndex
'		bc2.ArrayCopy2(ReplaceWith, 0, result, targetIndex, ReplaceWith.Length)
'		targetIndex = targetIndex + ReplaceWith.Length
'		prevIndex = i + SearchFor.Length
'		i = bc2.IndexOf2(Original, SearchFor, prevIndex)
'	Loop
'	If prevIndex < Original.Length Then
'		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, Original.Length - prevIndex)
'	End If
'	Return result
'End Sub

Public Sub doubleMap(analoginputvalue As Double,in_min As Double,in_max As Double,out_min As Double,out_max As Double) As Double
	Dim a As Double = (analoginputvalue - in_min) * (out_max - out_min) / (in_max - in_min) + out_min
	Return a
End Sub

Public Sub Round5(del As Double, mult As Double) As Double
	Dim a As Double = ((del + mult/2) / mult) * mult '- mult/2
	Return Floor (a)
End Sub

Public Sub Numb8(source As Double) As String
	Dim a As String = NumberFormat(source, 1, 8)
	Return a
End Sub

Public Sub Numb3(source As Double) As String
	Dim a As String = NumberFormat(source, 1, 3)
	Return a
End Sub

Public Sub Numb2(source As Double) As String
	Dim a As String = NumberFormat(source, 1, 2)
	Return a
End Sub

Public Sub Numb1(source As Double) As String
	Dim a As String = NumberFormat(source, 1, 1)
	Return a
End Sub

'Public Sub PrepareDataAndSaveSettings
'	Dim d(14) As Byte
'	d(0) = WorkMode
'	d(1) = Role
'	Main.bc.ArrayCopy2(GlobalStore.Slot0, 0, d, 2, 12)	'pair mac
'	Main.SDlog(Array As String("PrepareDataAndSaveSettings=", d)
'	SaveSettings(d)
'	
'	Load_Settings
'End Sub

Sub MyAbs(d As Double) As Double
	If d < 0 Then Return -d Else Return d
End Sub



Sub esp32_reboot_reason
	RunNative("getrebootreason", Null)
End Sub

#if c
void getrebootreason(B4R::Object* o) {
  esp_reset_reason_t reason = esp_reset_reason();
	if ((reason == ESP_RST_INT_WDT)) Serial.println("Restarted: ESP_RST_INT_WDT");
	if ((reason == ESP_RST_TASK_WDT)) Serial.println("Restarted: ESP_RST_TASK_WDT");
	if ((reason == ESP_RST_WDT)) Serial.println("Restarted: to ESP_RST_WDT"); 	
	if ((reason == ESP_RST_UNKNOWN)) Serial.println("Restarted: ESP_RST_UNKNOWN");
	if ((reason == ESP_RST_POWERON)) Serial.println("Restarted: ESP_RST_POWERON");
	if ((reason == ESP_RST_SW)) Serial.println("Restarted: ESP_RST_SW");
	if ((reason == ESP_RST_PANIC)) Serial.println("Restarted: ESP_RST_PANIC");
	if ((reason == ESP_RST_DEEPSLEEP)) Serial.println("Restarted: ESP_RST_DEEPSLEEP");
	if ((reason == ESP_RST_BROWNOUT)) Serial.println("Restarted: ESP_RST_BROWNOUT");
	if ((reason == ESP_RST_SDIO)) Serial.println("Restarted: ESP_RST_SDIO");
}
#end if

Public Sub ToUpperCase(s() As Byte)
	For i = 0 To s.Length - 1
		If s(i) >= 97 And s(i) <= 122 Then
			s(i) = s(i) - 32
		End If
	Next
End Sub

'Bubble sort
Sub SortArray(Values() As Double)
	Dim temp As Double
	Dim sorted As Boolean = False
	Do While sorted = False
		sorted = True
		For i = 0 To Values.Length - 2
			If Values(i) > Values(i + 1) Then
				temp = Values(i)
				Values(i) = Values(i + 1)
				Values(i + 1) = temp
				sorted = False
			End If
		Next
	Loop
End Sub

Sub Date_ToLog(tit As String)
	'Main.SDlog(Array As String(tit, ": ", NumberFormat(esp_ds1307.Hour, 2, 0), ":", NumberFormat(esp_ds1307.Minute, 2, 0), ":", NumberFormat(esp_ds1307.Sec, 2, 0), " (", NumberFormat(esp_ds1307.Date, 2, 0), "-", NumberFormat(esp_ds1307.Month, 2, 0), "-", NumberFormat(esp_ds1307.Year, 2, 0), ")"))
End Sub

Sub Date_Time As String
	Return "___"'JoinStrings(Array As String("20", NumberFormat(esp_ds1307.Year, 2, 0), "-", NumberFormat(esp_ds1307.Month, 2, 0), "-", NumberFormat(esp_ds1307.Date, 2, 0), " ", NumberFormat(esp_ds1307.Hour, 2, 0), ":", NumberFormat(esp_ds1307.Minute, 2, 0), ":", NumberFormat(esp_ds1307.Sec, 2, 0)))
End Sub

Sub SelfStatus As String
	Dim res As String = ""
	'If esp_ds1307.Ready_flag = False Then
		res = JoinStrings(Array As String(res, "Часы ds1307 не отвечают !; "))
	'End If
	'If esp_bme280.Ready_flag = False Then
		res = JoinStrings(Array As String(res, "Датчик bme280 не отвечает; "))
	'End If
	'If esp_bme280.Ready_flag = True And esp_bme280.isOK = False Then
		res = JoinStrings(Array As String(res, "Датчик bme280: нестабильные данные; "))
	'End If

	'If mcu_battery.isOK = False Then
		'If mcu_battery.PercentBat < 30 Then
			res = JoinStrings(Array As String(res, "Батарея ", 300, " %; "))
		'End If
	'End If

	'If esp_sd.Ready_flag Then
	'	Dim free As Float = esp_sd.SDFreeSpace(False)
	'	If free < 20 Then
	'		res = JoinStrings(Array As String(res, "Остаток места на SD-карте снижается = ", free,  " %; "))
	'	End If
	'End If
'	If interface.isWiFiConnected = False Then
'		
'	End If
	If res = "" Then res = "OK"
	Return res
End Sub

Sub SD_status As String
	Dim res As String = ""
	'If esp_sd.Ready_flag = False Then
		res = JoinStrings(Array As String(res, "SD-карта не доступна"))
	'End If
	If res = "" Then res = "OK"
	Return res
End Sub

Sub Tick As ULong
	'If esp_ds1307.Ready_flag = False Then Return 0
	Dim month As ULong
	Select 1
		Case 1
			month = 44640	'2678400
		Case 2
			month = 40320	'2419200
		Case 3
			month = 44640
		Case 4
			month = 43200	'2592000
		Case 5
			month = 44640
		Case 6
			month = 43200
		Case 7
			month = 44640
		Case 8
			month = 44640
		Case 9
			month = 43200
		Case 10
			month = 44640
		Case 11
			month = 43200
		Case 12
			month = 44640
	End Select
	Dim day As ULong =  24 * 60	'mins
	Dim hour As ULong = 60	'mins
	Dim res As ULong = (month + day + hour + 1) * 60 + 1	'seconds per any one year only, without year's data
	Return res
End Sub


Sub LoadSettings
'
'	Dim s As String = Main.Nvs.getString1("SSID")	'SSID
'	Main.SDlog(Array As String("EEPROM loaded SSID = ", s))
'	GlobalStore.Put(0, s.GetBytes)
'	Dim s As String = Main.Nvs.getString1("PASS")
'	Main.SDlog(Array As String("EEPROM loaded PASS = ", s))
'	GlobalStore.Put(1, s.GetBytes)	'pass
'	
'	Dim b As Byte = Main.Nvs.getByte("APmode", 1)
'	interface.APmode = IIf(b = 0, False, True)
'	Main.SDlog(Array As String("EEPROM loaded APmode = ", interface.APmode))
End Sub

Public Sub APname As String
Return "MYAPPNAME"'JoinStrings(Array As String(title, Main.bc.HexFromBytes(MacArray)))
End Sub

Sub StopWiFiAccessPoint
	RunNative("StopAP", Null)
End Sub

#if C
#include "esp_wifi.h"
void StopAP(B4R::Object* o) {
     WiFi.softAPdisconnect(true);
	 esp_wifi_disconnect();
	 esp_wifi_stop();
	 esp_wifi_start();
}
#end if

'Sub StartAccessPoint(ssid As String) As Boolean
'	RunNative("b4r_startap", ssid.GetBytes)
'End Sub
'
'#if C
'B4R::Object returnvalue_esp_others;
'
'B4R::Object* b4r_startap(B4R::Object* o) {
'   B4R::Array* b = (B4R::Array*)B4R::Object::toPointer(o);
'   char* ssid = (char*)b->data;
'   bool res = WiFi.softAP(ssid, "");
'   return returnvalue_esp_others.wrapNumber((byte)res);
'}
'#end if